-- name: [CS] The Conductor
-- description: Probably a bird\n\n\\#fcba41\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_Conductor = smlua_model_util_get_id("conductor_geo")

local TEX_Conductor_ICON = get_texture_info("conductor-icon")

local TEXT_MOD_NAME = "The conductor"

local VOICETABLE_Conductor = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'damagerecieve.ogg',
    [CHAR_SOUND_OOOF2] = 'damagerecieve2.ogg',
    [CHAR_SOUND_WAH2] ='jumppero2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'hit1.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'hit2.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'pung3.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'jump1.ogg','jumppero2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'jumppero2.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'triplejump.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'wallbonk.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = nil, -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = 'landing.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'longjump.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = 'landing.ogg',
    [CHAR_SOUND_DOH] = 'wallbonk.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'grabbingedge.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = nil, -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'long_distance.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'jump1.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'lifting.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'star_get.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Finale_Peckneck.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'damagerecieve.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = nil, -- Low health
    [CHAR_SOUND_ON_FIRE] = 'damagerecieve2.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = 'imatired.ogg', -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'salida-del-nivel.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'salida-del-nivel.ogg' -- Booted out of level
}

local PALETTE_Conductor = {
    [PANTS]  = "151415",
    [SHIRT]  = "151415",
    [GLOVES] = "2C2456",
    [SHOES]  = "9B3989",
    [HAIR]   = "F0D3C8",
    [SKIN]   = "FCBA41",
    [CAP]    = "151415",
}

local CAPTABLE_Conductor = {
    normal = smlua_model_util_get_id("Conductor_cap_normal_geo"),
    wing = smlua_model_util_get_id("Conductor_cap_wing_geo"),
    metal = smlua_model_util_get_id("Conductor_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("Conductor_cap_normal_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("The Conductor", "Director of the film Murder on the Owl Express", "Made by @Asplatim on twitter", {r = 252, g = 186, b = 65}, E_MODEL_Conductor, CT_MARIO, TEX_Conductor_ICON)
      _G.charSelect.character_add_caps(E_MODEL_Conductor, CAPTABLE_Conductor)

    _G.charSelect.character_add_palette_preset(E_MODEL_Conductor, PALETTE_Conductor)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_Conductor, VOICETABLE_Conductor)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Conductor then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Conductor then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end