-- name: [CS] Dj Grooves
-- description: "Magnificent! Stunning! This trophy is everything I desire... on the shelf of my living room!" —DJ Grooves \n\n\\#5E9BBD\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_DJGROOVES = smlua_model_util_get_id("DJGROOVES_geo")

local TEX_DJGROOVES_ICON = get_texture_info("dj-icon")

local TEXT_MOD_NAME = "DJGROOVES"

local VOICETABLE_DJGROOVES = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'DJ_Grooves_A_Ek.ogg',
    [CHAR_SOUND_OOOF2] = 'DJ_Grooves_A_Wha.ogg',
    [CHAR_SOUND_WAH2] = 'DJ_Grooves_A_Hoh.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'DJ_Grooves_A_Wa.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'DJ_Grooves_A_Ya.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'DJ_Grooves_A_Go.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'DJ_Grooves_A_Ha.ogg','DJ_Grooves_A_Hah.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'DJ_Grooves_A_Hah.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'DJ_Grooves_A_Gooooo.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'DJ_Grooves_A_Huh.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'grabbingedge_dj.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = 'DJ_Grooves_A_Hohohoooooo.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'DJ_Grooves_A_Gooooo.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'DJ_Grooves_A_Hoh.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'grabbingedge_dj.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = 'DJ_Grooves_A_Ek.ogg', -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'NOOOOOOOOOO.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'DJ_Grooves_A_Gooooo.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'DJ_Grooves_A_Yeh.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'DJ_Grooves_A_Gotcha.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'DJ_Grooves_A_WatchOut.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'DJ_Grooves_A_Ow.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = nil, -- Low health
    [CHAR_SOUND_ON_FIRE] = 'DJ_Grooves_A_Ek.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'NOOOOOOOOOO.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'DJ_Grooves_A_Ow.ogg' -- Booted out of level
}

local PALETTE_DJGROOVES = {
    [PANTS]  = "2E4986",
    [SHIRT]  = "C63634",
    [GLOVES] = "E6B850",
    [SHOES]  = "C63634",
    [HAIR]   = "191D24",
    [SKIN]   = "5E9BBD",
    [CAP]    = "5E9BBD",
}

local CAPTABLE_DJGROOVES = {
    normal = smlua_model_util_get_id("DJGROOVES_cap_normal_geo"),
    wing = smlua_model_util_get_id("DJGROOVES_cap_wing_geo"),
    metal = smlua_model_util_get_id("DJGROOVES_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("DJGROOVES_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Dj Grooves", "Moon Penguin", "Made by @Asplatim on twitter", {r = 91, g = 155, b = 213}, E_MODEL_DJGROOVES, CT_MARIO, TEX_DJGROOVES_ICON)
      _G.charSelect.character_add_caps(E_MODEL_DJGROOVES, CAPTABLE_DJGROOVES)

    _G.charSelect.character_add_palette_preset(E_MODEL_DJGROOVES, PALETTE_DJGROOVES)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_DJGROOVES, VOICETABLE_DJGROOVES)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DJGROOVES then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DJGROOVES then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end