-- name: [CS]A Hat in Time ModPack!!
-- description: A modpack of 5 characters from a hat in time! \n\n\\#F2BD1D\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_MUSTACHE = smlua_model_util_get_id("MUSTACHE_geo")

local TEX_MUSTACHE_ICON = get_texture_info("mustache-icon")

local TEXT_MOD_NAME = "MUSTACHE"

local VOICETABLE_MUSTACHE = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'Hurt2.ogg',
    [CHAR_SOUND_OOOF2] = 'Hurt4.ogg',
    [CHAR_SOUND_WAH2] = 'MUSTACHE_Woosh.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'hitting1.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'attack_ya02.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'MuGirl_2017_09_Boom.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'Jump3.ogg','Jump2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'Jump2.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'ComeOn.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'Hurt3.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'MuGirl_2017_09_Ughn.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = nil, -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'MuGirl_2017_09_Yeah.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'MuGirl_2017_09_Eugh.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'MuGirl_2017_09_Ughn.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = 'MuGirl_2017_09_HoMumble.ogg', -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'MuGirl_2017_09_Noooo.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MuGirl_2017_09_Booyah.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'MuGirl_2017_09_HoMumble.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'MuGirl_2017_09_Booyah.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MuGirl_2017_09_Booyah.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'Hurt6.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = nil, -- Low health
    [CHAR_SOUND_ON_FIRE] = 'MuGirl_2017_09_Eugh.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'MuGirl_2017_09_Urgh.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'MuGirl_2017_09_Ouch.ogg' -- Booted out of level
}

local PALETTE_MUSTACHE = {
    [PANTS]  = "A886CB",
    [SHIRT]  = "FF5045",
    [GLOVES] = "FD8E7D",
    [SHOES]  = "73FFBA",
    [HAIR]   = "FFD55D",
    [SKIN]   = "F0BAF2",
    [CAP]    = "301A43",
}

local CAPTABLE_MUSTACHE = {
    normal = smlua_model_util_get_id("MUSTACHE_cap_normal_geo"),
    wing = smlua_model_util_get_id("MUSTACHE_cap_wing_geo"),
    metal = smlua_model_util_get_id("MUSTACHE_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("MUSTACHE_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Mustache Girl", "exists", "Made by @Asplatim on twitter", {r = 255, g = 80, b = 69}, E_MODEL_MUSTACHE, CT_MARIO, TEX_MUSTACHE_ICON)
      _G.charSelect.character_add_caps(E_MODEL_MUSTACHE, CAPTABLE_MUSTACHE)

    _G.charSelect.character_add_palette_preset(E_MODEL_MUSTACHE, PALETTE_MUSTACHE)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_MUSTACHE, VOICETABLE_MUSTACHE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MUSTACHE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MUSTACHE then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end